%
clc;
clear all;
format short g
%
% --- state space block parameters, units [N,s,mm]
%
R     =   320.0;
Rdyn  =   315.0;
cphi  =     1.0e+08; 
dphi  =     4.0e+04;
JB    =   550.0;
JR    =  1540.0;
cus   =     0.0;
%
% --- input block parameters
%
Fz0  = 5000.0;
Fz1  =    0.0;
fFz  =    2.0*pi*1.0;
sy0  =    0.0;
sy1  =    0.0;
fsy  =    2.0*pi*1.0;
gam0 =    0.0;
gam1 =    0.0;
fgam =    2.0*pi*1.0;
Omy0 =   31.25;
Omy00=   31.25;
Omy1 =    5.00;
fOmy =    2.0*pi*0.5;
V0   = Rdyn*Omy00;
V1   =    0.0;
fV   =    0.0*pi*1.0;
dcu  = R*R*cus/V0;
%
% --- controller parameters
%
Ki =  16000.0;
Kp = 140000.0;
%
% --- state space block matrixes
%
A1 = [1.0,  0.0, 0.0, 0.0;     %phibd  
      0.0,  1.0, 0.0, 0.0;     %phird     
      0.0,  0.0,  JB,  JB;     %phibdd
      0.0,  0.0,  0.0, JR];    %phird
  
A2 = [0.0,       0.0,  1.0,      0.0;   %phib   
      0.0,       0.0,  0.0,      1.0;   %phir
      -cphi,     0.0, -dphi-dcu,-dcu;   %phibd
       cphi-Ki, -Ki,   dphi-Kp, -Kp];   %phibd
  
B1 = [0.0;             
      0.0; 
     -R, ; 
      0.0];  
  
A  = inv(A1)*A2;
B  = inv(A1)*B1;
eig(A)
C  = [0.0,0.0,1.0,1.0];
D  = [0.0,0.0];
X0 = [0.0,0.0,0.0,Omy00]; 
 