#include "mexFunction.h"
#pragma comment(lib, "libmx.lib")
#pragma comment(lib, "libmat.lib")
#pragma comment(lib, "libmex.lib")
//
#include "RMOD_K_Formula_Opti.h"
//
// --- the standard interface to matlab
//
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[] )
{
   int     len2;
   double *input1,*input2,*output;

   static CRMOD_K_Formula_Opti RMOD_K_Formula;
//
// --- connect output array to plhs
//
	RMOD_K_Formula.set_draw3d(0);

   nlhs    = 1;
   plhs[0] = mxCreateDoubleMatrix( 1,1,mxREAL );
   output  = mxGetPr( plhs[0] );
//
// --- get input1 argument
//
   input1 = mxGetPr( prhs[0] );
//
// --- check number of input arguments, disable solution if out of order
//
   if ( nrhs != 2 )
   {
      printf ( " number of arguments should be 2: array of design variables, call identifier \n" );
      *output = 1.0e+10;
      return;
   }
//
// --- check dimension of input2 arguments, disable solution if out of order
//
   len2 = mxGetM ( prhs[1] );
   if ( len2 != 1 )
   {
      printf ( " dimension of argument 2 should be 1: call identifier (0=initialise, 1=run, -1=terminate)\n" );
      *output = 1.0e+10;
      return;
   }
   input2 = mxGetPr( prhs[1] );
//
// --- call the formula
//
   *output = RMOD_K_Formula.Set_TargetValue ( input1,input2 );
//
// --- prompt dimension of the problem
//
	if ( (int) input2[0] == 0 ) 
	{
		printf (" number of design variables = %d\n",(int)*output);
	}
}



