#pragma once
#include "DiscreteFormula.h"
#include "ContinusFormula.h"
#include "FormulaDefines.h"
#include <string.h>
#include <stdlib.h>

class CRMOD_K_Formula_Opti
{
public:
    CRMOD_K_Formula_Opti();
   ~CRMOD_K_Formula_Opti();

	char   DataFileName   [1024];
	char   DataResultName [1024];
	char   DataCornerName [1024];
	char   OptiFileName   [1024];
	char   WorkDirectory  [1024];
	char   JobTitle       [1024];

	void Set_Logfile  (FILE*  FPOINTER) { LOGFILE = FPOINTER; }; 

   double Get_desmax       ( int l )      { return ( desmax[l] );} 
   double Get_desmin       ( int l )      { return ( desmin[l] );} 
   void   Set_desvar       ( int i, int ivalue ) { if ( i > -1 && i < Nmodelparameter) isdesvar[i] = ivalue;} 
   void   Set_version      ( int ivalue ) { version         = ivalue;} 
   void   Set_LoadedState  ( int ivalue ) { IsLoaded        = ivalue;} 
   void   Set_AllocState   ( int ivalue ) { Isallocated     = ivalue;} 
   void   Set_NModelPar    ( int ivalue ) { Nmodelparameter = ivalue;} 
   int    Is_desvar        ( int i )      { return ( isdesvar[i] );} 
   int    Get_NModelPar    ( )            { return Nmodelparameter;} 
   int    Get_version      ( )            { return version;};
   int    Get_TargetData   ( );	

   double Set_TargetValue  ( double *design, double *modeofcall ); 
   int    ReadFile_Formula ( double *design );
	void   freemem          ( );
   void   get_variables    ( const double *design );
   void   get_charvalue    ( const char *s, char *s2 );
   int    get_integevalue  ( const char *s );
   double get_doublevalue  ( const char *s );
   void   get_CornerKy     ( );

	double* Get_Optidata () { return optidata; };
	double* Get_Simdata  () { return resultdata; };
	int*    Get_MeainfoD () { return TargetDirectionPerFile; };
	int*    Get_MeainfoN () { return PointsPerFile; };
	int     Get_MeainfoF () { return NumberOfFiles; };
	int     Get_MeainfoA () { return NumberOfAdditionalFiles; };

   inline void set_draw3d ( int mode ) {myDiscreteFormula->set_draw3d( mode );};

	void   Get_Changes     (double *formulavalues) { myDiscreteFormula->DiscreteFormula_GetVariables (input1); };

   int    m1;
   double input1[NMODELPARAMETER],input3[Ninput3],output[Noutput];
   double targetvalue;

protected:

	FILE   *LOGFILE;
   void   check_design    ( FILE *OUTPUT, const double *design, const int j, int *l );
   int    get_designinfo  ( const char *s, double *designmin, double *designmax );

   int    m2,m3,ierr,model,NumberOfPoints,MemoryStatus,NumberOfDesignVariables;
	int    NumberOfFiles,NumberOfAdditionalFiles,Nmodelparameter,version;
	int    Isallocated,IsLoaded;
   int    *PointsPerFile,*TargetDirectionPerFile;
   int    isdesvar[NMODELPARAMETER];
   double input2[Ninput2],input4;
	double vslmax,vslide0;
   double desmin[NMODELPARAMETER],desmax[NMODELPARAMETER];
   double *VT,*DA;
   double *optidata;
	double *resultdata;

   CDiscreteFormula *myDiscreteFormula;
   CContinusFormula *myContinusFormula;
};
